/*************************************************
 * CAMELOID Secure End-to-End Telephony System
 * Copyright (C) 2005  Dr. Tek                     
 ************************************************/


/* Algorithms */
#define         CAMELOID_ALG_PY         1
#define         CAMELOID_ALG_PHELIX     2
#define		CAMELOID_ALG_SERPENT	3
#define		CAMELOID_ALG_TWOFISH	4
#define		CAMELOID_ALG_CAST6	5
#define		CAMELOID_ALG_RIJNDAEL	6

#define		CAMELOID_ALGO_COUNT	6

typedef ECRYPT_ctx      PyContext;

typedef struct
{
        int alg;
        PyContext       py_ctx;
        PhelixContext   phelix_ctx;
	SerpentKey_t	serpent_ctx;
	TwofishContext  twofish_ctx;
	CAST6Context	cast6_ctx;
	RijndaelContext rijndael_ctx;
	u8 		keydatahash[24];
} cameloid_kc_t;

