/*************************************************
 * CAMELOID Secure End-to-End Telephony System
 * Copyright (C) 2005  Dr. Tek                     
 ************************************************/

#include "cameloid.h"
#include "cameloid_memory.h"
#include "cameloid_voice.h"
#include "cameloid_protocol.h"
#include "cameloid_functions.h"

/*
 *
 *	
 *	CAMELOID packet construction functions
 *
 *
 */



#ifdef VIDEO_CAP

__inline__
void cameloid_build_auth_packet(cameloid_auth_t *ath, u8 *nonce, u16 type)
{
        cameloid_destroy_memory((u8 *) ath,PKT_AT_SIZE);
        memcpy(ath->proto_id,CAMELOID_PROTO_IDENT,4);
        memcpy(ath->nonce,nonce,CAMELOID_NONCE_SIZE);
        ath->pkt_type = type;
}

#else

__inline__
void cameloid_build_auth_packet(cameloid_auth_t *ath, u8 *nonce, u16 type)
{
	cameloid_destroy_memory((u8 *) ath,PKT_AT_SIZE);
	memcpy(ath->proto_id,CAMELOID_PROTO_IDENT,4);
	memcpy(ath->nonce,nonce,CAMELOID_NONCE_SIZE);
 	ath->pkt_type = type;
}

#endif

__inline__
void cameloid_build_cr_packet(cameloid_cr_pkt_t *crp, u8 *data, u8 *nonce, u16 type)
{
	cameloid_build_auth_packet(&crp->ath,nonce,type);
	memcpy(crp->data,data,32);
}
