#include <signal.h>

#define		CAMELOID_MODE_ENCRYPT		1
#define		CAMELOID_MODE_DECRYPT		2


__inline__ void cameloid_generate_key(u8 *, u32 , u8 *, u8);
__inline__ void cameloid_crypt_data(u8,u8 *,u32,u8 *, cameloid_kc_t *);
__inline__ void cameloid_build_cr_packet(cameloid_cr_pkt_t *,u8 *, u8 *, u16);

#ifdef	VIDEO_CAP
__inline__ void cameloid_build_auth_packet(cameloid_auth_t *, u8 *, u16);
#else
__inline__ void cameloid_build_auth_packet(cameloid_auth_t *,u8 *, u16);
#endif



__inline__ void half_duplex_switch(int);
__inline__ int  cameloid_read_half_duplex(int,int,int,u16,u32,cameloid_kc_t *);
__inline__ int  cameloid_write_half_duplex(int,int,int,cameloid_kc_t *);
__inline__ void cameloid_key_setup(int ,const u8 *, u32 , cameloid_kc_t *);
__inline__ int  cameloid_compress(short *, u8 *, u32);
__inline__ void cameloid_decompress(u8 *, short *, u32);
__inline__ void cameloid_play_ring(u8 *);
__inline__ u8 * cameloid_hash_and_show_md5(const u8 *,u32);
__inline__ int  cameloid_net_read(int,u8 *,u32);
__inline__ int  cameloid_net_read_udp(int,u8 *,u32);
__inline__ u8 * cameloid_algo_to_name(int);
__inline__ int  cameloid_name_to_algo(u8 *);
__inline__ void cameloid_set_sound_trigger(int,int);
__inline__ void cameloid_close_sound(int);
__inline__ u8   cameloid_get_random_algo(void);
__inline__ void cameloid_get_rng_bytes(int, u8 *, u32);
__inline__ void cameloid_hmac_md5(const u8 *,int, const u8 *,int, const u8 *, int, u8 *);
__inline__ void cameloid_add_gf256(u8 *,u8 *, u32);
__inline__ void clear_reset_screen(void);
__inline__ int lstat(const char *, struct stat *);

