/*************************************************
 * CAMELOID Secure End-to-End Telephony System
 * Copyright (C) 2005  Dr. Tek
 ************************************************/

#include "cameloid.h"

aes_context aeskeyctx;

__inline__
void cameloid_init_rng(int randomfd)
{
	u8 keybuf[32];
	
	cameloid_destroy_memory(keybuf,32);	
	while((read(randomfd,keybuf,32)) < 32)
	{
		continue;
	}

	/* setup 256-bit rijndael key */
	aes_set_key(&aeskeyctx,keybuf,256);

}


__inline__
void
cameloid_get_rng_bytes(int randomfd, u8 *data, u32 size)
{
	register u32 i = 0, n = 0, cnt = 0;
	u8 random_ctr[16];
	static int init_rng = 0;

	if(!init_rng)
	{
		cameloid_init_rng(randomfd);
		init_rng = 1;		
	}	

	cameloid_destroy_memory(random_ctr,16);
	
	while((read(randomfd,data,size))< size)
	{
		continue;
	}

	while((read(randomfd,random_ctr,16)) < 16)
	{
		continue;
	}

	for(cnt = 0, i = size; i > 0; --i, cnt++)
	{
		if((cnt % 16) == 0)
		{
			RijndaelEncrypt(&aeskeyctx,random_ctr,random_ctr);
			for(n = 16; n > 0; --n)
			{
				random_ctr[n-1]++;
				if(random_ctr[n-1] !=  0)
					break;
			}
		}
		data[i-1] ^= random_ctr[cnt % 16];
	}
			

}
