#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "server_callbacks.h"
#include "server_interface.h"
#include "support.h"



extern void enable_video_pause(int);
extern void kill_connection(int);

void
on_mainwindow_destroy                  (GtkObject       *object,
                                        gpointer         user_data)
{
	kill_connection(0);
	return;
}


void
on_resetbutton_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	kill_connection(0);
	return;
}


void
on_pausebutton_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
	
	enable_video_pause(0);
	return;
}



gboolean
on_brightscale_change_value            (GtkRange        *range,
                                        GtkScrollType    scroll,
                                        gdouble          value,
                                        gpointer         user_data)
{

	pic.brightness = (unsigned short) value;
	ioctl(videofd, VIDIOCSPICT, &pic);


  return FALSE;
}


gboolean
on_contrastscale_change_value          (GtkRange        *range,
                                        GtkScrollType    scroll,
                                        gdouble          value,
                                        gpointer         user_data)
{

	pic.contrast = (unsigned short) value;	
	ioctl(videofd, VIDIOCSPICT, &pic);


  return FALSE;
}


gboolean
on_huescale_change_value               (GtkRange        *range,
                                        GtkScrollType    scroll,
                                        gdouble          value,
                                        gpointer         user_data)
{

	pic.hue = (unsigned short) value;
	ioctl(videofd, VIDIOCSPICT, &pic);


  return FALSE;
}


gboolean
on_colourscale_change_value            (GtkRange        *range,
                                        GtkScrollType    scroll,
                                        gdouble          value, 
                                        gpointer         user_data)
{

	pic.colour = (unsigned short) value;
	ioctl(videofd, VIDIOCSPICT, &pic);
               
  return FALSE;
}


void
on_okaybutton_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
        okay_button_clicked = 1;
        gtk_widget_hide(alertwinptr);
        gtk_main_quit();
        return;
}
 

